Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/molecules.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -179,5 +179,4 @@
   bond *FirstBond = NULL, *SecondBond = NULL; // Other bonds in double bond case to determine "other" plane
   atom *FirstOtherAtom = NULL, *SecondOtherAtom = NULL, *ThirdOtherAtom = NULL; // pointer to hydrogen atoms to be added
-  int i;  // loop variable
   double b,l,d,f,g, alpha, factors[NDIM];    // hold temporary values in triple bond case for coordination determination
   vector OrthoVector1, OrthoVector2;  // temporary vectors in coordination construction
@@ -253,5 +252,5 @@
     case 2:
       // determine two other bonds (warning if there are more than two other) plus valence sanity check
-      for (i=0;i<NumBond;i++) {
+      for (int i=0;i<NumBond;i++) {
         if (BondList[i] != TopBond) {
           if (FirstBond == NULL) {
@@ -312,5 +311,5 @@
       FirstOtherAtom->x.Zero();
       SecondOtherAtom->x.Zero();
-      for(i=NDIM;i--;) { // rotate by half the bond angle in both directions (InBondVector is bondangle = 0 direction)
+      for(int i=NDIM;i--;) { // rotate by half the bond angle in both directions (InBondVector is bondangle = 0 direction)
         FirstOtherAtom->x.x[i] = InBondVector.x[i] * cos(bondangle) + OrthoVector1.x[i] * (sin(bondangle));
         SecondOtherAtom->x.x[i] = InBondVector.x[i] * cos(bondangle) + OrthoVector1.x[i] * (-sin(bondangle));
@@ -319,5 +318,5 @@
       SecondOtherAtom->x.Scale(&BondRescale);
       //*out << Verbose(3) << "ReScaleCheck: " << FirstOtherAtom->x.Norm() << " and " << SecondOtherAtom->x.Norm() << "." << endl;
-      for(i=NDIM;i--;) { // and make relative to origin atom
+      for(int i=NDIM;i--;) { // and make relative to origin atom
         FirstOtherAtom->x.x[i] += TopOrigin->x.x[i]; 
         SecondOtherAtom->x.x[i] += TopOrigin->x.x[i];
@@ -439,5 +438,5 @@
   int NumberOfAtoms = 0; // atom number in xyz read
   int i, j; // loop variables
-  atom *first = NULL;  // pointer to added atom
+  atom *Walker = NULL;  // pointer to added atom
   char shorthand[3];  // shorthand for atom name
   ifstream xyzfile;   // xyz file
@@ -457,5 +456,5 @@
 
   for(i=0;i<NumberOfAtoms;i++){
-    first = new atom;
+    Walker = new atom;
     getline(xyzfile,line,'\n');
     istringstream *item = new istringstream(line);
@@ -466,12 +465,12 @@
     *item >> x[1];
     *item >> x[2];
-    first->type = elemente->FindElement(shorthand);
-    if (first->type == NULL) {
+    Walker->type = elemente->FindElement(shorthand);
+    if (Walker->type == NULL) {
       cerr << "Could not parse the element at line: '" << line << "', setting to H.";
-      first->type = elemente->FindElement(1);
+      Walker->type = elemente->FindElement(1);
     }
     for(j=NDIM;j--;)
-      first->x.x[j] = x[j];
-     AddAtom(first);  // add to molecule
+      Walker->x.x[j] = x[j];
+     AddAtom(Walker);  // add to molecule
     delete(item);
   }
@@ -710,17 +709,17 @@
 }; 
 
-/** Centers the center of gravity of the atoms at (0,0,0).
+/** Returns vector pointing to center of gravity.
  * \param *out output stream for debugging
- * \param *center return vector for translation vector
- */
-void molecule::CenterGravity(ofstream *out, vector *center)
-{
+ * \return pointer to center of gravity vector
+ */
+vector * molecule::DetermineCenterOfGravity(ofstream *out)
+{
+	atom *ptr = start->next;  // start at first in list
+	vector *a = new vector();
+	vector tmp;
   double Num = 0;
-  atom *ptr = start->next;  // start at first in list
-  vector tmp;
-  
-  for(int i=NDIM;i--;) // zero center vector
-    center->x[i] = 0.;
-    
+	
+	a->Zero();
+
   if (ptr != end) {   //list not empty?
     while (ptr->next != end) {  // continue with second if present
@@ -729,7 +728,25 @@
       tmp.CopyVector(&ptr->x);
       tmp.Scale(ptr->type->mass);  // scale by mass
-      center->AddVector(&tmp);       
-    }
-    center->Scale(-1./Num); // divide through total mass (and sign for direction)
+      a->AddVector(&tmp);       
+    }
+    a->Scale(-1./Num); // divide through total mass (and sign for direction)
+  }
+  *out << Verbose(1) << "Resulting center of gravity: ";
+  a->Output(out);
+  *out << endl;
+  return a;
+};
+
+/** Centers the center of gravity of the atoms at (0,0,0).
+ * \param *out output stream for debugging
+ * \param *center return vector for translation vector
+ */
+void molecule::CenterGravity(ofstream *out, vector *center)
+{
+  if (center == NULL) {
+    DetermineCenter(*center);
+    Translate(center);
+    delete(center);
+  } else {
     Translate(center);
   }
@@ -775,8 +792,8 @@
 };
 
-/** Determines center of gravity (yet not considering atom masses).
- * \param CenterOfGravity reference to return vector
- */
-void molecule::DetermineCenterOfGravity(vector &CenterOfGravity)
+/** Determines center of molecule (yet not considering atom masses).
+ * \param Center reference to return vector
+ */
+void molecule::DetermineCenter(vector &Center)
 {
   atom *Walker = start;
@@ -788,5 +805,5 @@
   
   do {
-    CenterOfGravity.Zero();
+    Center.Zero();
     flag = true;
     while (Walker->next != end) {
@@ -815,5 +832,5 @@
         TestVector.AddVector(&TranslationVector);
         TestVector.MatrixMultiplication(matrix);
-        CenterOfGravity.AddVector(&TestVector);
+        Center.AddVector(&TestVector);
         cout << Verbose(1) << "Vector is: ";
         TestVector.Output((ofstream *)&cout);
@@ -828,5 +845,5 @@
             TestVector.AddVector(&TranslationVector);
             TestVector.MatrixMultiplication(matrix);
-            CenterOfGravity.AddVector(&TestVector);
+            Center.AddVector(&TestVector);
             cout << Verbose(1) << "Hydrogen Vector is: ";
             TestVector.Output((ofstream *)&cout);
@@ -838,6 +855,110 @@
     }
   } while (!flag);
-  Free((void **)&matrix, "molecule::DetermineCenterOfGravity: *matrix");
-  CenterOfGravity.Scale(1./(double)AtomCount);
+  Free((void **)&matrix, "molecule::DetermineCenter: *matrix");
+  Center.Scale(1./(double)AtomCount);
+};
+
+/** Transforms/Rotates the given molecule into its principal axis system.
+ * \param *out output stream for debugging
+ * \param DoRotate whether to rotate (true) or only to determine the PAS.
+ */
+void molecule::PrincipalAxisSystem(ofstream *out, bool DoRotate)
+{
+	atom *ptr = start;  // start at first in list
+	double InertiaTensor[NDIM*NDIM];
+	vector *CenterOfGravity = DetermineCenterOfGravity(out);
+
+	CenterGravity(out, CenterOfGravity);
+	
+	// reset inertia tensor	
+	for(int i=0;i<NDIM*NDIM;i++)
+		InertiaTensor[i] = 0.;
+	
+	// sum up inertia tensor
+	while (ptr->next != end) {
+		ptr = ptr->next;
+		vector x;
+		x.CopyVector(&ptr->x);
+		//x.SubtractVector(CenterOfGravity);
+		InertiaTensor[0] += ptr->type->mass*(x.x[1]*x.x[1] + x.x[2]*x.x[2]);
+		InertiaTensor[1] += ptr->type->mass*(-x.x[0]*x.x[1]);
+		InertiaTensor[2] += ptr->type->mass*(-x.x[0]*x.x[2]);
+		InertiaTensor[3] += ptr->type->mass*(-x.x[1]*x.x[0]);
+		InertiaTensor[4] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[2]*x.x[2]);
+		InertiaTensor[5] += ptr->type->mass*(-x.x[1]*x.x[2]);
+		InertiaTensor[6] += ptr->type->mass*(-x.x[2]*x.x[0]);
+		InertiaTensor[7] += ptr->type->mass*(-x.x[2]*x.x[1]);
+		InertiaTensor[8] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[1]*x.x[1]);
+	}
+	// print InertiaTensor for debugging
+	*out << "The inertia tensor is:" << endl;
+	for(int i=0;i<NDIM;i++) {
+	  for(int j=0;j<NDIM;j++)
+	    *out << InertiaTensor[i*NDIM+j] << " ";
+	  *out << endl;
+	}
+	*out << endl;
+	
+	// diagonalize to determine principal axis system
+	gsl_eigen_symmv_workspace *T = gsl_eigen_symmv_alloc(NDIM);
+	gsl_matrix_view m = gsl_matrix_view_array(InertiaTensor, NDIM, NDIM);
+	gsl_vector *eval = gsl_vector_alloc(NDIM);
+	gsl_matrix *evec = gsl_matrix_alloc(NDIM, NDIM);
+	gsl_eigen_symmv(&m.matrix, eval, evec, T);
+	gsl_eigen_symmv_free(T);
+	gsl_eigen_symmv_sort(eval, evec, GSL_EIGEN_SORT_ABS_DESC);
+	
+	for(int i=0;i<NDIM;i++) {
+		*out << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i);
+		*out << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl;
+	}
+	
+	// check whether we rotate or not
+	if (DoRotate) {
+	  *out << Verbose(1) << "Transforming molecule into PAS ... "; 
+	  // the eigenvectors specify the transformation matrix
+	  ptr = start;
+	  while (ptr->next != end) {
+	    ptr = ptr->next;
+	    ptr->x.MatrixMultiplication(evec->data);
+	  }
+	  *out << "done." << endl;
+
+	  // summing anew for debugging (resulting matrix has to be diagonal!)
+	  // reset inertia tensor 
+    for(int i=0;i<NDIM*NDIM;i++)
+      InertiaTensor[i] = 0.;
+    
+    // sum up inertia tensor
+    ptr = start;
+    while (ptr->next != end) {
+      ptr = ptr->next;
+      vector x;
+      x.CopyVector(&ptr->x);
+      //x.SubtractVector(CenterOfGravity);
+      InertiaTensor[0] += ptr->type->mass*(x.x[1]*x.x[1] + x.x[2]*x.x[2]);
+      InertiaTensor[1] += ptr->type->mass*(-x.x[0]*x.x[1]);
+      InertiaTensor[2] += ptr->type->mass*(-x.x[0]*x.x[2]);
+      InertiaTensor[3] += ptr->type->mass*(-x.x[1]*x.x[0]);
+      InertiaTensor[4] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[2]*x.x[2]);
+      InertiaTensor[5] += ptr->type->mass*(-x.x[1]*x.x[2]);
+      InertiaTensor[6] += ptr->type->mass*(-x.x[2]*x.x[0]);
+      InertiaTensor[7] += ptr->type->mass*(-x.x[2]*x.x[1]);
+      InertiaTensor[8] += ptr->type->mass*(x.x[0]*x.x[0] + x.x[1]*x.x[1]);
+    }
+    // print InertiaTensor for debugging
+    *out << "The inertia tensor is:" << endl;
+    for(int i=0;i<NDIM;i++) {
+      for(int j=0;j<NDIM;j++)
+        *out << InertiaTensor[i*NDIM+j] << " ";
+      *out << endl;
+    }
+    *out << endl;
+	}
+	
+	// free everything
+	delete(CenterOfGravity);
+	gsl_vector_free(eval);
+	gsl_matrix_free(evec);
 };
 
@@ -1234,5 +1355,5 @@
   if ((Binder->next != last) && (Binder->next->Type == Undetermined)) {
     *out << Verbose(0) << "No Depth-First-Search analysis performed so far, calling ..." << endl;
-    Subgraphs = DepthFirstSearchAnalysis(out, false, MinimumRingSize);
+    Subgraphs = DepthFirstSearchAnalysis(out, MinimumRingSize);
     while (Subgraphs->next != NULL) {
       Subgraphs = Subgraphs->next;
@@ -1249,5 +1370,4 @@
   return No;
 };
-
 /** Returns Shading as a char string.
  * \param color the Shading
@@ -1453,5 +1573,5 @@
             for(j=0;j<NumberOfBondsPerAtom[Walker->nr];j++)
               NoBonds += ListOfBondsPerAtom[Walker->nr][j]->BondDegree;
-	          //*out << Verbose(3) << "Walker: " << (int)Walker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
+	          *out << Verbose(3) << "Walker: " << (int)Walker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
 	          if ((int)(Walker->type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check NoBonds of other atom
 	            // count valence of second partner
@@ -1459,5 +1579,5 @@
               for(j=0;j<NumberOfBondsPerAtom[OtherWalker->nr];j++)
                 NoBonds += ListOfBondsPerAtom[OtherWalker->nr][j]->BondDegree;
-              //*out << Verbose(3) << "OtherWalker: " << (int)OtherWalker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
+              *out << Verbose(3) << "OtherWalker: " << (int)OtherWalker->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
 	            if ((int)(OtherWalker->type->NoValenceOrbitals) > NoBonds) // increase bond degree by one
                 ListOfBondsPerAtom[Walker->nr][i]->BondDegree++;
@@ -1471,12 +1591,12 @@
 	  *out << Verbose(1) << "I detected " << BondCount << " bonds in the molecule with distance " << bonddistance << "." << endl;
 		
-//	  // output bonds for debugging (if bond chain list was correctly installed)
-//	  *out << Verbose(1) << endl << "From contents of bond chain list:";
-//	  bond *Binder = first;
-//    while(Binder->next != last) {
-//      Binder = Binder->next;
-//			*out << *Binder << "\t" << endl;
-//    }
-//    *out << endl;
+	  // output bonds for debugging (if bond chain list was correctly installed)
+	  *out << Verbose(1) << endl << "From contents of bond chain list:";
+	  bond *Binder = first;
+    while(Binder->next != last) {
+      Binder = Binder->next;
+			*out << *Binder << "\t" << endl;
+    }
+    *out << endl;
   } else
   	*out << Verbose(1) << "AtomCount is " << AtomCount << ", thus no bonds, no connections!." << endl; 
@@ -1490,9 +1610,8 @@
  * We use the algorithm from [Even, Graph Algorithms, p.62].
  * \param *out output stream for debugging
- * \param ReturnStack true - return pointer to atom stack of separable components, false - return NULL
  * \param *&MinimumRingSize contains smallest ring size in molecular structure on return or -1 if no rings were found
  * \return list of each disconnected subgraph as an individual molecule class structure
  */
-MoleculeLeafClass * molecule::DepthFirstSearchAnalysis(ofstream *out, bool ReturnStack, int *&MinimumRingSize)
+MoleculeLeafClass * molecule::DepthFirstSearchAnalysis(ofstream *out, int *&MinimumRingSize)
 {
   class StackClass<atom *> *AtomStack;
@@ -2006,8 +2125,7 @@
  * \param *path path to file
  * \param *FragmentList empty, filled on return
- * \param IsAngstroem whether we have Ansgtroem or bohrradius
  * \return true - parsing successfully, false - failure on parsing (FragmentList will be NULL)
  */
-bool molecule::ParseKeySetFile(ofstream *out, char *path, Graph *&FragmentList, bool IsAngstroem)
+bool molecule::ParseKeySetFile(ofstream *out, char *path, Graph *&FragmentList)
 {
   bool status = true;
@@ -2186,10 +2304,10 @@
 {
   ifstream File;
-  stringstream line;
+  stringstream filename;
   bool status = true;
   char *buffer = (char *) Malloc(sizeof(char)*MAXSTRINGSIZE, "molecule::CheckAdjacencyFileAgainstMolecule: *buffer");
   
-  line << path << "/" << FRAGMENTPREFIX << ADJACENCYFILE;
-  File.open(line.str().c_str(), ios::out);
+  filename << path << "/" << FRAGMENTPREFIX << ADJACENCYFILE;
+  File.open(filename.str().c_str(), ios::out);
   *out << Verbose(1) << "Looking at bond structure stored in adjacency file and comparing to present one ... ";
   if (File != NULL) {
@@ -2493,10 +2611,10 @@
 
   // ===== 2. perform a DFS analysis to gather info on cyclic structure and a list of disconnected subgraphs =====
-  Subgraphs = DepthFirstSearchAnalysis(out, false, MinimumRingSize);
+  Subgraphs = DepthFirstSearchAnalysis(out, MinimumRingSize);
   // fill the bond structure of the individually stored subgraphs
   Subgraphs->next->FillBondStructureFromReference(out, this, (FragmentCounter = 0), ListOfLocalAtoms, false);  // we want to keep the created ListOfLocalAtoms
 
   // ===== 3. if structure still valid, parse key set file and others =====
-  FragmentationToDo = FragmentationToDo && ParseKeySetFile(out, configuration->configpath, ParsedFragmentList, configuration->GetIsAngstroem());
+  FragmentationToDo = FragmentationToDo && ParseKeySetFile(out, configuration->configpath, ParsedFragmentList);
 
   // ===== 4. check globally whether there's something to do actually (first adaptivity check)
@@ -3013,5 +3131,5 @@
 //          *out << ", who has no son in this fragment molecule." << endl; 
 #ifdef ADDHYDROGEN
-//          *out << Verbose(3) << "Adding Hydrogen to " << Runner->Name << " and a bond in between." << endl;
+          //*out << Verbose(3) << "Adding Hydrogen to " << Runner->Name << " and a bond in between." << endl;
           Leaf->AddHydrogenReplacementAtom(out, ListOfBondsPerAtom[FatherOfRunner->nr][i], Runner, FatherOfRunner, OtherFather, ListOfBondsPerAtom[FatherOfRunner->nr],NumberOfBondsPerAtom[FatherOfRunner->nr], IsAngstroem);
 #endif
@@ -3421,5 +3539,4 @@
   KeyStack AtomStack;
   atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::PowerSetGenerator: **PredecessorList");
-  KeySet::iterator runner;
   int RootKeyNr = FragmentSearch.Root->nr;
   int Counter = FragmentSearch.FragmentCounter;
@@ -3816,6 +3933,6 @@
 {
   Graph ***FragmentLowerOrdersList = NULL;
-  int Order, NumLevels, NumMolecules, TotalNumMolecules = 0, *NumMoleculesOfOrder = NULL;
-  int counter = 0;
+  int NumLevels, NumMolecules, TotalNumMolecules = 0, *NumMoleculesOfOrder = NULL;
+  int counter = 0, Order;
   int UpgradeCount = RootStack.size();
   KeyStack FragmentRootStack;
@@ -3831,6 +3948,4 @@
 
   // initialise the fragments structure
-  FragmentSearch.BondsPerSPList = (bond **) Malloc(sizeof(bond *)*Order*2, "molecule::PowerSetGenerator: ***BondsPerSPList");
-  FragmentSearch.BondsPerSPCount = (int *) Malloc(sizeof(int)*Order, "molecule::PowerSetGenerator: *BondsPerSPCount");
   FragmentSearch.ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::PowerSetGenerator: *ShortestPathList");
   FragmentSearch.Labels = (int *) Malloc(sizeof(int)*AtomCount, "molecule::PowerSetGenerator: *Labels");
@@ -4059,6 +4174,6 @@
   if (result) {
     *out << Verbose(5) << "Calculating Centers of Gravity" << endl;
-    DetermineCenterOfGravity(CenterOfGravity);
-    OtherMolecule->DetermineCenterOfGravity(OtherCenterOfGravity);
+    DetermineCenter(CenterOfGravity);
+    OtherMolecule->DetermineCenter(OtherCenterOfGravity);
     *out << Verbose(5) << "Center of Gravity: ";
     CenterOfGravity.Output(out);
Index: src/molecules.hpp
===================================================================
--- src/molecules.hpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/molecules.hpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -13,4 +13,5 @@
 #include <gsl/gsl_vector.h>
 #include <gsl/gsl_matrix.h>
+#include <gsl/gsl_eigen.h>
 #include <gsl/gsl_heapsort.h>
 
@@ -39,6 +40,6 @@
 #define KeySet set<int>
 #define NumberValuePair pair<int, double>
-#define Graph map<KeySet, NumberValuePair, KeyCompare >
-#define GraphPair pair<KeySet, NumberValuePair >
+#define Graph map <KeySet, NumberValuePair, KeyCompare >
+#define GraphPair pair <KeySet, NumberValuePair >
 #define KeySetTestPair pair<KeySet::iterator, bool>
 #define GraphTestPair pair<Graph::iterator, bool>
@@ -265,14 +266,17 @@
   void CenterEdge(ofstream *out, vector *max); 
   void CenterOrigin(ofstream *out, vector *max); 
-  void CenterGravity(ofstream *out, vector *max); 
+  void CenterGravity(ofstream *out, vector *max);
   void Translate(const vector *x);
   void Mirror(const vector *x);
   void Align(vector *n);
   void Scale(double **factor);
-  void DetermineCenterOfGravity(vector &CenterOfGravity);
+  void DetermineCenter(vector &center);
+  vector * DetermineCenterOfGravity(ofstream *out);
   void SetBoxDimension(vector *dim);
   double * ReturnFullMatrixforSymmetric(double *cell_size);
   void ScanForPeriodicCorrection(ofstream *out);
-
+	void PrincipalAxisSystem(ofstream *out, bool DoRotate);
+	double VolumeOfConvexEnvelope(ofstream *out, bool IsAngstroem);
+	
   bool CheckBounds(const vector *x) const;
   void GetAlignVector(struct lsq_params * par) const;
@@ -283,5 +287,5 @@
   
   // Graph analysis
-  MoleculeLeafClass * DepthFirstSearchAnalysis(ofstream *out, bool ReturnStack, int *&MinimumRingSize);
+  MoleculeLeafClass * DepthFirstSearchAnalysis(ofstream *out, int *&MinimumRingSize);
   void CyclicStructureAnalysis(ofstream *out, class StackClass<bond *> *BackEdgeStack, int *&MinimumRingSize);
   bond * FindNextUnused(atom *vertex);
@@ -303,5 +307,5 @@
   bool ParseOrderAtSiteFromFile(ofstream *out, char *path);
   bool StoreOrderAtSiteFile(ofstream *out, char *path);
-  bool ParseKeySetFile(ofstream *out, char *filename, Graph *&FragmentList, bool IsAngstroem);
+  bool ParseKeySetFile(ofstream *out, char *filename, Graph *&FragmentList);
   bool StoreKeySetFile(ofstream *out, Graph &KeySetList, char *path);
   bool StoreForcesFile(ofstream *out, MoleculeListClass *BondFragments, char *path, int *SortIndex);
@@ -392,4 +396,5 @@
     char *configpath;
     char *configname;
+    bool FastParsing;
     
     private:
Index: src/periodentafel.cpp
===================================================================
--- src/periodentafel.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/periodentafel.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -217,6 +217,7 @@
 
   // fill valence DB per element
-  strncat(filename, path, MAXSTRINGSIZE);
-  strncpy(filename, STANDARDVALENCEDB, MAXSTRINGSIZE-strlen(filename));
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDVALENCEDB, MAXSTRINGSIZE-strlen(filename));
   infile.open(filename);
   if (infile != NULL) {
@@ -226,5 +227,5 @@
     	infile >> FindElement((int)tmp)->Valence;
     	infile >> ws;
-    	//cout << Verbose(3) << "Element " << (int)tmp << " has " << find_element((int)tmp)->Valence << " valence electrons." << endl;
+    	//cout << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->Valence << " valence electrons." << endl;
     }
     infile.close();
@@ -234,6 +235,7 @@
 
   // fill valence DB per element
-  strncat(filename, path, MAXSTRINGSIZE);
-  strncpy(filename, STANDARDORBITALDB, MAXSTRINGSIZE-strlen(filename));
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDORBITALDB, MAXSTRINGSIZE-strlen(filename));
   infile.open(filename);
   if (infile != NULL) {
@@ -243,5 +245,5 @@
       infile >> FindElement((int)tmp)->NoValenceOrbitals;
       infile >> ws;
-      //cout << Verbose(3) << "Element " << (int)tmp << " has " << find_element((int)tmp)->NoValenceOrbitals << " number of singly occupied valence orbitals." << endl;
+      //cout << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->NoValenceOrbitals << " number of singly occupied valence orbitals." << endl;
     }
     infile.close();
@@ -251,6 +253,7 @@
   
   // fill H-BondDistance DB per element
-  strncat(filename, path, MAXSTRINGSIZE);
-  strncpy(filename, STANDARDHBONDDISTANCEDB, MAXSTRINGSIZE-strlen(filename));
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDHBONDDISTANCEDB, MAXSTRINGSIZE-strlen(filename));
   infile.open(filename);
   if (infile != NULL) {
@@ -263,5 +266,5 @@
       infile >> ptr->HBondDistance[2];
     	infile >> ws;
-      //cout << Verbose(3) << "Element " << (int)tmp << " has " << find_element((int)tmp)->HBondDistance[0] << " Angstrom typical distance to hydrogen." << endl;
+      //cout << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->HBondDistance[0] << " Angstrom typical distance to hydrogen." << endl;
     }
     infile.close();
@@ -271,6 +274,7 @@
   
   // fill H-BondAngle DB per element
-  strncat(filename, path, MAXSTRINGSIZE);
-  strncpy(filename, STANDARDHBONDANGLEDB, MAXSTRINGSIZE-strlen(filename));
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDHBONDANGLEDB, MAXSTRINGSIZE-strlen(filename));
   infile.open(filename);
   if (infile != NULL) {
@@ -289,4 +293,7 @@
     otherstatus = false;
   
+  if (!otherstatus)
+    cerr << "ERROR: Something went wrong while parsing the databases!" << endl;
+  
   return status;
 };
@@ -298,7 +305,8 @@
   bool result = true;
   ofstream f;
-  
-  if (filename == NULL)
-    f.open("elements.db");
+  char file[MAXSTRINGSIZE];
+  
+  if (filename == STANDARDELEMENTSDB)
+    f.open(file);
   else
     f.open(filename);
Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/vector.cpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -13,4 +13,8 @@
  */
 vector::vector() { x[0] = x[1] = x[2] = 0.; };
+
+/** Constructor of class vector.
+ */
+vector::vector(double x1, double x2, double x3) { x[0] = x1; x[1] = x2; x[2] = x3; };
 
 /** Desctructor of class vector.
@@ -111,4 +115,16 @@
 };
 
+/** projects this vector onto plane defined by \a *y.
+ * \param *y array to normal vector of plane
+ * \return \f$\langle x, y \rangle\f$
+ */
+void vector::ProjectOntoPlane(const vector *y)
+{
+  vector tmp;
+  tmp.CopyVector(y);
+  tmp.Scale(Projection(y));
+  this->SubtractVector(&tmp);
+};
+
 /** Calculates the projection of a vector onto another \a *y.
  * \param *y array to second vector
@@ -117,5 +133,5 @@
 double vector::Projection(const vector *y) const
 {
-  return (ScalarProduct(y)/Norm()/y->Norm());
+  return (ScalarProduct(y));
 };
 
@@ -150,11 +166,28 @@
 };
 
+/** Zeros all components of this vector.
+ */
+void vector::One(double one)
+{
+  for (int i=NDIM;i--;)
+    this->x[i] = one;
+};
+
+/** Initialises all components of this vector.
+ */
+void vector::Init(double x1, double x2, double x3)
+{ 
+  x[0] = x1;
+  x[1] = x2;
+  x[2] = x3;
+};
+
 /** Calculates the angle between this and another vector.
  * \param *y array to second vector
- * \return \f$\frac{\langle x, y \rangle}{|x||y|}\f$
+ * \return \f$\acos\bigl(frac{\langle x, y \rangle}{|x||y|}\bigr)\f$
  */
 double vector::Angle(vector *y) const
 {
-  return (this->ScalarProduct(y)/(this->Norm()*y->Norm()));
+  return acos(this->ScalarProduct(y)/Norm()/y->Norm()); 
 };
 
@@ -354,5 +387,5 @@
 {
   double projection;
-  projection = ScalarProduct(n)/((vector *)n)->ScalarProduct(n);    // remove constancy from n (keep as logical one)
+  projection = ScalarProduct(n)/n->ScalarProduct(n);    // remove constancy from n (keep as logical one)
   // withdraw projected vector twice from original one
   cout << Verbose(1) << "Vector: ";
@@ -385,10 +418,10 @@
     return false;
   }
-  cout << Verbose(4) << "relative, first plane coordinates:";
-  x1.Output((ofstream *)&cout);
-  cout << endl;
-  cout << Verbose(4) << "second plane coordinates:";
-  x2.Output((ofstream *)&cout);
-  cout << endl;
+//  cout << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  cout << endl;
+//  cout << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  cout << endl;
 
   this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
@@ -419,10 +452,10 @@
     return false;
   }
-  cout << Verbose(4) << "relative, first plane coordinates:";
-  x1.Output((ofstream *)&cout);
-  cout << endl;
-  cout << Verbose(4) << "second plane coordinates:";
-  x2.Output((ofstream *)&cout);
-  cout << endl;
+//  cout << Verbose(4) << "relative, first plane coordinates:";
+//  x1.Output((ofstream *)&cout);
+//  cout << endl;
+//  cout << Verbose(4) << "second plane coordinates:";
+//  x2.Output((ofstream *)&cout);
+//  cout << endl;
 
   this->x[0] = (x1.x[1]*x2.x[2] - x1.x[2]*x2.x[1]);
@@ -458,5 +491,5 @@
  * \return true - success, false - failure (null vector given)
  */
-bool vector::GetOneNormalVector(const vector *vector)
+bool vector::GetOneNormalVector(const vector *GivenVector)
 {
   int Components[NDIM]; // contains indices of non-zero components
@@ -466,5 +499,5 @@
 
   cout << Verbose(4);
-  vector->Output((ofstream *)&cout);
+  GivenVector->Output((ofstream *)&cout);
   cout << endl;
   for (j=NDIM;j--;)
@@ -472,5 +505,5 @@
   // find two components != 0
   for (j=0;j<NDIM;j++)
-    if (fabs(vector->x[j]) > MYEPSILON)
+    if (fabs(GivenVector->x[j]) > MYEPSILON)
       Components[Last++] = j;
   cout << Verbose(4) << Last << " Components != 0: (" << Components[0] << "," << Components[1] << "," << Components[2] << ")" << endl;
@@ -479,9 +512,9 @@
     case 3:  // threecomponent system
     case 2:  // two component system
-      norm = sqrt(1./(vector->x[Components[1]]*vector->x[Components[1]]) + 1./(vector->x[Components[0]]*vector->x[Components[0]]));
+      norm = sqrt(1./(GivenVector->x[Components[1]]*GivenVector->x[Components[1]]) + 1./(GivenVector->x[Components[0]]*GivenVector->x[Components[0]]));
       x[Components[2]] = 0.;
       // in skp both remaining parts shall become zero but with opposite sign and third is zero
-      x[Components[1]] = -1./vector->x[Components[1]] / norm;
-      x[Components[0]] = 1./vector->x[Components[0]] / norm;
+      x[Components[1]] = -1./GivenVector->x[Components[1]] / norm;
+      x[Components[0]] = 1./GivenVector->x[Components[0]] / norm;
       return true;
       break;
@@ -498,4 +531,20 @@
 };
 
+/** Determines paramter needed to multiply this vector to obtain intersection point with plane defined by \a *A, \a *B and \a *C.
+ * \param *A first plane vector
+ * \param *B second plane vector
+ * \param *C third plane vector
+ * \return scaling parameter for this vector
+ */
+double vector::CutsPlaneAt(vector *A, vector *B, vector *C)
+{
+//  cout << Verbose(3) << "For comparison: ";
+//  cout << "A " << A->Projection(this) << "\t"; 
+//  cout << "B " << B->Projection(this) << "\t"; 
+//  cout << "C " << C->Projection(this) << "\t"; 
+//  cout << endl;
+  return A->Projection(this);
+};
+
 /** Creates a new vector as the one with least square distance to a given set of \a vectors.
  * \param *vectors set of vectors
@@ -519,5 +568,5 @@
      gsl_multimin_fminimizer_nmsimplex;
    gsl_multimin_fminimizer *s = NULL;
-   gsl_vector *ss, *x;
+   gsl_vector *ss, *y;
    gsl_multimin_function minex_func;
  
@@ -528,5 +577,5 @@
    /* Initial vertex size vector */
    ss = gsl_vector_alloc (np);
-   x = gsl_vector_alloc (np);
+   y = gsl_vector_alloc (np);
  
    /* Set all step sizes to 1 */
@@ -538,5 +587,5 @@
 	
 	 for (i=NDIM;i--;)
-		gsl_vector_set(x, i, (vectors[0]->x[i] - vectors[1]->x[i])/2.); 
+		gsl_vector_set(y, i, (vectors[0]->x[i] - vectors[1]->x[i])/2.); 
 	 
    /* Initialize method and iterate */
@@ -546,5 +595,5 @@
  
    s = gsl_multimin_fminimizer_alloc (T, np);
-   gsl_multimin_fminimizer_set (s, &minex_func, x, ss);
+   gsl_multimin_fminimizer_set (s, &minex_func, y, ss);
  
    do
@@ -575,5 +624,5 @@
   for (i=(size_t)np;i--;)
     this->x[i] = gsl_vector_get(s->x, i);
-   gsl_vector_free(x);
+   gsl_vector_free(y);
    gsl_vector_free(ss);
    gsl_multimin_fminimizer_free (s);
Index: src/vector.hpp
===================================================================
--- src/vector.hpp	(revision d250b29e2b8e1c054b7f93c4f475f36dfb7a3a33)
+++ src/vector.hpp	(revision 8a3e457fdc8672973ca81864d2f77e092e907b83)
@@ -10,4 +10,5 @@
 
   vector();
+  vector(double x1, double x2, double x3);
   ~vector();
 
@@ -23,5 +24,8 @@
   void CopyVector(const vector *y);
   void RotateVector(const vector *y, const double alpha);
+  void ProjectOntoPlane(const vector *y);
   void Zero(); 
+  void One(double one);
+  void Init(double x1, double x2, double x3);
   void Normalize();
   void Translate(const vector *x);
@@ -35,4 +39,5 @@
   void LinearCombinationOfVectors(const vector *x1, const vector *x2, const vector *x3, double *factors);
   
+  double CutsPlaneAt(vector *A, vector *B, vector *C);
   bool GetOneNormalVector(const vector *x1);
   bool MakeNormalVector(const vector *y1);
